#ifndef _Cap_H
 #define _Cap_H


#include "delay.h"

#define Sensor2      RB2
#define Sensor2_tris TRISB2

#pragma jis //        

//   
#define Sensor  RB4
#define Sensor_out {TRISB4=0; LATB4=0;}
#define Sensor_in  TRISB4=1

volatile unsigned long Tmp=0;

void Ramka (void)
{
 cursor(0,2);
 for(char i=0;i<84;i++)
  LCD_data(0xC0);
 LCD_data(0xFF);
 LCD_data(0xFF); 
 cursor(0,4);
 LCD_data(0xFF);
 LCD_data(0xFF); 
 cursor(82,3);
 LCD_data(0xFF);
 LCD_data(0xFF); 
 cursor(82,4);
 LCD_data(0xFF);
 LCD_data(0xFF); 
 cursor(0,5);
 for(char i=0;i<84;i++)
  LCD_data(0x03); 
}

unsigned long Capacitance (void)
{
 unsigned long Cap=0;
 Sensor_out;
 if(Sensor2)
 {
  _delay_ms(100);
  Sensor_in;
  _delay_us(1);
  while(!Sensor)
   Cap++;
 }
 else
 {
  _delay_ms(500);
  Sensor_in;
  NOP();
  while(!Sensor)
   Cap++;
 }
 return Cap;
}



void Cap_test (void)
{
/*************************************************************************/
/*                                            */
/*************************************************************************/
 unsigned char flag2=0;
 unsigned char x=3,y=3;
 unsigned long C;
 cursor(20,0);
 printf(""); 
 Sensor2_tris=1;
 if(Sensor2) //    
 {
  cursor(0,1);
  printf("0,01 - 1"); 
  flag2=1;   //  "0,01 - 1"   
 }
 else        //    
 {
  cursor(0,1);
  printf(" 3500 ");
  flag2=0;   //  " 3500 "   
 }
 Ramka();
/*************************************************************************/
/*                                                       */
/*************************************************************************/
 while(1)
 {
  long C=Capacitance();
  //       -  
  if(C>1) 
   LED_on;
  else
   LED_off;
  if(Sensor2) //     
  {
   if(!flag2) //   "0,01 - 1"     - 
   {
    cursor(0,1);
    printf("0,01 - 1"); 
    flag2=1;
  //   
    cursor(x,y);
    printf_big("      ");
    LCD_comand (y+0x41);
    printf(" ");
   }
   C*=100;
   C/=227;
   if(C!=Tmp)//       
   {         //   
    cursor(x,y);
    printf_big("      ");
    LCD_comand (y+0x41);
    printf(" ");
   }
   Tmp=C;    //     
   cursor(x,y);
   if(C<10000) //    100 
   {
    print_10_big(C,1); //     
    LCD_comand (y+0x41);
    printf("");      //    ""
   }
   else if(C<100000) //    100 
   {
    print_10_big(C,2); //     
    LCD_comand (y+0x41);
    printf("");      //    ""
   }
   else                // 
   {
    C/=1000;
    print_10_big(C,1); //     
    LCD_comand (y+0x41);
    printf("");     //    ""
   }
  }
  else       //     
  {
   if(flag2) //   "0,1 - 3500"     - 
   {
    cursor(0,1);
    printf("0,1 - 3500"); 
    flag2=0;
  //   
    cursor(x,y);
    printf_big("      ");
    LCD_comand (y+0x41);
    printf(" ");
   }
   C/=62;
   if(C!=Tmp)//       
   {         //   
    cursor(x,y);
    printf_big("      ");
    LCD_comand (y+0x41);
    printf(" ");
   }
   Tmp=C;    //     
    cursor(x,y); 
    if(C<9999) //    999,9 
     print_10_big(C,0); //    
    else       // 
     print_10_big(C,3); //   
    LCD_comand (y+0x41);
    printf("");
   
  }
  _delay_ms(500);
 }
}
#endif