/**************************************************************************************/
/*     8448,  Nokia 5110 (3310), : Philips PCD8544       */
/*    pic18f1320    HI-TECH Software,    */
/* PICC18  9.66.      */
/* Microchip,     .                           */ 
/* :                                                                 */
/* email: b_bikman@ukr.net                                                            */     
/**************************************************************************************/
#include <htc.h>
#include "LCD.h"
#include "Bin2_10.h"

#pragma jis //        (     "main.c"!!!)


/*                    Nokia 5110               */

/*    ( 1 ,    */
void LCD_init(void)
{
 CLC_tris=0;
 DIN_tris=0;
 DC_tris=0;
 CE_tris=0;
 RST_tris=0;
 RST=0;
 __delay_ms(5);
 RST=1;
 LCD_comand (0x21);
 LCD_comand (0xC2);
 LCD_comand (0x13);  // ???
 LCD_comand (0x20);
 LCD_comand (0x9);
 cursor(0,0);
 LCD_data (0);
 __delay_ms(2);
 LCD_comand (0x8);
 LCD_comand (0xC);
 cursor(0,0);
 cursor(0,0);
 LCD_data (0);
 __delay_ms(2);
}




/*            1-                 */
/*       ,      */
/*      "LCD_comand();"   */
/*                 "LCD_data();"                    */

void LCD_send (unsigned char Data)
{
 unsigned char i;
 for(i=0;i<8;i++)
 {
  DIN=0;
  if(Data&0x80)
   DIN=1;
  CLC=1;
  NOP();
  CLC=0;
  Data=(Data<<1);
 }
}


/*                                */
void LCD_clear(void)
{
 unsigned int i;
 for(i=0;i<504;i++)
  LCD_data(0);
 cursor(0,0);
}


/*                     */

void LCD_comand (unsigned char Data)
{
 DC=0;
 CE=0;
 LCD_send (Data);
 CE=1;
}
/*                              */

void LCD_data (unsigned char Data)
{
 DC=1;
 CE=0;
 LCD_send (Data);
 CE=1;
}


/*         +1      */
/* 1   6  ( 14   ) */

void cursor_txt (unsigned char x, unsigned char y)
{
 cursor((x*6),y);
}

/*        */

void cursor (unsigned char x, unsigned char y)
{
 Tmp_y=y;
 Tmp_x=x;
 x=x+0x80;
 y=y+0x40;
 LCD_comand (y);
 LCD_comand (x);
}


/*                              */

void Print_img (const char img[])
{
 for(int k=0;k<504;k++)  //  504 
 {
  LCD_data(img[k]);
 }
}


/*   ASCII  (   0x7F  0xBF) */


const char symbol [] =
{
0x00, 0x00, 0x00, 0x00, 0x00, 0x00,   // 
0x00, 0x00, 0x00, 0x2f, 0x00, 0x00,   // !
0x00, 0x00, 0x07, 0x00, 0x07, 0x00,   // "
0x00, 0x14, 0x7f, 0x14, 0x7f, 0x14,   // #
0x00, 0x24, 0x2a, 0x7f, 0x2a, 0x12,   // $
0x00, 0x23, 0x13, 0x08, 0x64, 0x62,   // %
0x00, 0x36, 0x49, 0x55, 0x22, 0x50,   // &
0x00, 0x00, 0x05, 0x03, 0x00, 0x00,   // '
0x00, 0x00, 0x1c, 0x22, 0x41, 0x00,   // (
0x00, 0x00, 0x41, 0x22, 0x1c, 0x00,   // )
0x00, 0x14, 0x08, 0x3E, 0x08, 0x14,   // *
0x00, 0x08, 0x08, 0x3E, 0x08, 0x08,   // +
0x00, 0x00, 0x00, 0xA0, 0x60, 0x00,   // ,
0x00, 0x08, 0x08, 0x08, 0x08, 0x08,   // -
0x00, 0x00, 0x60, 0x60, 0x00, 0x00,   // .
0x00, 0x20, 0x10, 0x08, 0x04, 0x02,   // /
0x00, 0x3E, 0x51, 0x49, 0x45, 0x3E,   // 0
0x00, 0x00, 0x42, 0x7F, 0x40, 0x00,   // 1
0x00, 0x42, 0x61, 0x51, 0x49, 0x46,   // 2
0x00, 0x21, 0x41, 0x45, 0x4B, 0x31,   // 3
0x00, 0x18, 0x14, 0x12, 0x7F, 0x10,   // 4
0x00, 0x27, 0x45, 0x45, 0x45, 0x39,   // 5
0x00, 0x3C, 0x4A, 0x49, 0x49, 0x30,   // 6
0x00, 0x01, 0x71, 0x09, 0x05, 0x03,   // 7
0x00, 0x36, 0x49, 0x49, 0x49, 0x36,   // 8
0x00, 0x06, 0x49, 0x49, 0x29, 0x1E,   // 9
0x00, 0x00, 0x36, 0x36, 0x00, 0x00,   // :
0x00, 0x00, 0x56, 0x36, 0x00, 0x00,   // ;
0x00, 0x08, 0x14, 0x22, 0x41, 0x00,   // <
0x00, 0x14, 0x14, 0x14, 0x14, 0x14,   // =
0x00, 0x00, 0x41, 0x22, 0x14, 0x08,   // >
0x00, 0x02, 0x01, 0x51, 0x09, 0x06,   // ?
0x00, 0x32, 0x49, 0x59, 0x51, 0x3E,   // @
0x00, 0x7C, 0x12, 0x11, 0x12, 0x7C,   // A
0x00, 0x7F, 0x49, 0x49, 0x49, 0x36,   // B
0x00, 0x3E, 0x41, 0x41, 0x41, 0x22,   // C
0x00, 0x7F, 0x41, 0x41, 0x22, 0x1C,   // D
0x00, 0x7F, 0x49, 0x49, 0x49, 0x41,   // E
0x00, 0x7F, 0x09, 0x09, 0x09, 0x01,   // F
0x00, 0x3E, 0x41, 0x49, 0x49, 0x7A,   // G
0x00, 0x7F, 0x08, 0x08, 0x08, 0x7F,   // H
0x00, 0x00, 0x41, 0x7F, 0x41, 0x00,   // I
0x00, 0x20, 0x40, 0x41, 0x3F, 0x01,   // J
0x00, 0x7F, 0x08, 0x14, 0x22, 0x41,   // K
0x00, 0x7F, 0x40, 0x40, 0x40, 0x40,   // L
0x00, 0x7F, 0x02, 0x0C, 0x02, 0x7F,   // M
0x00, 0x7F, 0x04, 0x08, 0x10, 0x7F,   // N
0x00, 0x3E, 0x41, 0x41, 0x41, 0x3E,   // O
0x00, 0x7F, 0x09, 0x09, 0x09, 0x06,   // P
0x00, 0x3E, 0x41, 0x51, 0x21, 0x5E,   // Q
0x00, 0x7F, 0x09, 0x19, 0x29, 0x46,   // R
0x00, 0x46, 0x49, 0x49, 0x49, 0x31,   // S
0x00, 0x01, 0x01, 0x7F, 0x01, 0x01,   // T
0x00, 0x3F, 0x40, 0x40, 0x40, 0x3F,   // U
0x00, 0x1F, 0x20, 0x40, 0x20, 0x1F,   // V
0x00, 0x3F, 0x40, 0x38, 0x40, 0x3F,   // W
0x00, 0x63, 0x14, 0x08, 0x14, 0x63,   // X
0x00, 0x07, 0x08, 0x70, 0x08, 0x07,   // Y
0x00, 0x61, 0x51, 0x49, 0x45, 0x43,   // Z
0x00, 0x00, 0x7F, 0x41, 0x41, 0x00,   // [
0x00, 0x00, 0x06, 0x09, 0x09, 0x06,   // 0x27 ()
0x00, 0x00, 0x41, 0x41, 0x7F, 0x00,   // ]
0x00, 0x04, 0x02, 0x01, 0x02, 0x04,   // ^
0x00, 0x40, 0x40, 0x40, 0x40, 0x40,   // _
0x00, 0x00, 0x03, 0x05, 0x00, 0x00,   // `
0x00, 0x20, 0x54, 0x54, 0x54, 0x78,   // a
0x00, 0x7F, 0x48, 0x44, 0x44, 0x38,   // b
0x00, 0x38, 0x44, 0x44, 0x44, 0x20,   // c
0x00, 0x38, 0x44, 0x44, 0x48, 0x7F,   // d
0x00, 0x38, 0x54, 0x54, 0x54, 0x18,   // e
0x00, 0x08, 0x7E, 0x09, 0x01, 0x02,   // f
0x00, 0x18, 0xA4, 0xA4, 0xA4, 0x7C,   // g
0x00, 0x7F, 0x08, 0x04, 0x04, 0x78,   // h
0x00, 0x00, 0x44, 0x7D, 0x40, 0x00,   // i
0x00, 0x40, 0x80, 0x84, 0x7D, 0x00,   // j
0x00, 0x7F, 0x10, 0x28, 0x44, 0x00,   // k
0x00, 0x00, 0x41, 0x7F, 0x40, 0x00,   // l
0x00, 0x7C, 0x04, 0x18, 0x04, 0x78,   // m
0x00, 0x7C, 0x08, 0x04, 0x04, 0x78,   // n
0x00, 0x38, 0x44, 0x44, 0x44, 0x38,   // o
0x00, 0xFC, 0x24, 0x24, 0x24, 0x18,   // p
0x00, 0x18, 0x24, 0x24, 0x18, 0xFC,   // q
0x00, 0x7C, 0x08, 0x04, 0x04, 0x08,   // r
0x00, 0x48, 0x54, 0x54, 0x54, 0x20,   // s
0x00, 0x04, 0x3F, 0x44, 0x40, 0x20,   // t
0x00, 0x3C, 0x40, 0x40, 0x20, 0x7C,   // u
0x00, 0x1C, 0x20, 0x40, 0x20, 0x1C,   // v
0x00, 0x3C, 0x40, 0x30, 0x40, 0x3C,   // w
0x00, 0x44, 0x28, 0x10, 0x28, 0x44,   // x
0x00, 0x1C, 0xA0, 0xA0, 0xA0, 0x7C,   // y
0x00, 0x44, 0x64, 0x54, 0x4C, 0x44,   // z
0x00, 0x00, 0x10, 0x7C, 0x82, 0x00,   // {
0x00, 0x00, 0x00, 0xFF, 0x00, 0x00,   // |
0x00, 0x00, 0x82, 0x7C, 0x10, 0x00,   // }
0x00, 0x10, 0x08, 0x10, 0x10, 0x08,   // ~ 
/*   ASCII  "0x7F"  "0xBF"        */
/* .   "Print_txt()"  */
/*,     ASCII    */
0x00, 0x7C, 0x12, 0x11, 0x12, 0x7C,   // 
0x00, 0x7F, 0x49, 0x49, 0x49, 0x31,   // 
0x00, 0x7F, 0x49, 0x49, 0x49, 0x36,   // 
0x00, 0x7F, 0x01, 0x01, 0x01, 0x01,   // 
0x00, 0x60, 0x3E, 0x21, 0x3F, 0x60,   // 
0x00, 0x7F, 0x49, 0x49, 0x49, 0x41,   // 
0x00, 0x77, 0x08, 0x7F, 0x08, 0x77,   // 
0x00, 0x22, 0x41, 0x41, 0x49, 0x36,   // 
0x00, 0x7F, 0x10, 0x08, 0x04, 0x7F,   // 
0x00, 0x7C, 0x21, 0x12, 0x09, 0x7C,   // 
0x00, 0x7F, 0x08, 0x14, 0x22, 0x41,   // 
0x00, 0x40, 0x3C, 0x02, 0x01, 0x7F,   // 
0x00, 0x7F, 0x02, 0x0C, 0x02, 0x7F,   // 
0x00, 0x7F, 0x08, 0x08, 0x08, 0x7F,   // 
0x00, 0x3E, 0x41, 0x41, 0x41, 0x3E,   // 
0x00, 0x7F, 0x01, 0x01, 0x01, 0x7F,   // 
0x00, 0x7F, 0x09, 0x09, 0x09, 0x06,   // 
0x00, 0x3E, 0x41, 0x41, 0x41, 0x22,   // 
0x00, 0x01, 0x01, 0x7F, 0x01, 0x01,   // 
0x00, 0x47, 0x28, 0x10, 0x08, 0x07,   // 
0x00, 0x0E, 0x11, 0x7F, 0x11, 0x0E,   // 
0x00, 0x63, 0x14, 0x08, 0x14, 0x63,   // 
0x00, 0x3F, 0x20, 0x20, 0x3F, 0x60,   // 
0x00, 0x07, 0x08, 0x08, 0x08, 0x7F,   // 
0x00, 0x7F, 0x40, 0x7C, 0x40, 0x7F,   // 
0x00, 0x3F, 0x20, 0x3C, 0x20, 0x7F,   // 
0x00, 0x01, 0x7F, 0x48, 0x48, 0x30,   // 
0x00, 0x7F, 0x44, 0x38, 0x00, 0x7F,   // 
0x00, 0x7F, 0x48, 0x48, 0x48, 0x30,   // 
0x00, 0x41, 0x41, 0x49, 0x2A, 0x1C,   // 
0x00, 0x7F, 0x08, 0x3E, 0x41, 0x3E,   // 
0x00, 0x46, 0x29, 0x19, 0x09, 0x7F,   // 
0x00, 0x20, 0x54, 0x54, 0x54, 0x78,   // 
0x00, 0x3C, 0x4A, 0x4A, 0x49, 0x31,   // 
0x00, 0x7C, 0x54, 0x54, 0x28, 0x00,   // 
0x00, 0x7C, 0x04, 0x04, 0x04, 0x0c,   //  
0x00, 0x60, 0x38, 0x24, 0x24, 0x7C,   // 
0x00, 0x38, 0x54, 0x54, 0x54, 0x18,   // 
0x00, 0x6C, 0x10, 0x7C, 0x10, 0x6C,   // 
0x00, 0x44, 0x44, 0x54, 0x54, 0x28,   // 
0x00, 0x7C, 0x20, 0x10, 0x08, 0x7C,   // 
0x00, 0x78, 0x42, 0x24, 0x12, 0x78,   // 
0x00, 0x7C, 0x10, 0x28, 0x44, 0x00,   // 
0x00, 0x20, 0x44, 0x3C, 0x04, 0x7C,   // 
0x00, 0x7C, 0x08, 0x10, 0x08, 0x7C,   // 
0x00, 0x7C, 0x10, 0x10, 0x10, 0x7C,   // 
0x00, 0x38, 0x44, 0x44, 0x44, 0x38,   // 
0x00, 0x7C, 0x04, 0x04, 0x04, 0x7C,   // 
0x00, 0xFC, 0x24, 0x24, 0x24, 0x18,   // 
0x00, 0x38, 0x44, 0x44, 0x44, 0x20,   // 
0x00, 0x04, 0x04, 0x7C, 0x04, 0x04,   // 
0x00, 0x1C, 0xA0, 0xA0, 0xA0, 0x7C,   // y
0x00, 0x18, 0x24, 0x7C, 0x24, 0x18,   // 
0x00, 0x44, 0x28, 0x10, 0x28, 0x44,   // 
0x00, 0x7C, 0x40, 0x40, 0x40, 0xFC,   // 
0x00, 0x0C, 0x10, 0x10, 0x10, 0x7C,   // 
0x00, 0x7C, 0x40, 0x78, 0x40, 0x7C,   // 
0x00, 0x7C, 0x40, 0x78, 0x40, 0xFC,   // 
0x00, 0x04, 0x7C, 0x50, 0x50, 0x20,   // 
0x00, 0x7C, 0x50, 0x20, 0x00, 0x7C,   // 
0x00, 0x7C, 0x50, 0x50, 0x20, 0x00,   // 
0x00, 0x44, 0x54, 0x54, 0x54, 0x38,   // 
0x00, 0x7C, 0x10, 0x38, 0x44, 0x38,   // 
0x00, 0x48, 0x54, 0x34, 0x14, 0x7C,   // 
};

/*                  */



void printf (const char * Dtm, ...)
{
 Dtm[14];
 char z=0;
 while(Dtm[z]!='\0')
{
 Dt=Dtm[z];
 if(Dt>9)        // ,     
 {
  if(Dt>0x7D)
   Dt=(Dt-0x41); //         ASCCI
  Dt=(Dt-0x20);  //         ASCCI
 }
 else
  Dt=Dt+16;      // 16-  ='0'
 unsigned char i;
 Dt=Dt*6;
 for(i=0;i<6; i++)
 {
  LCD_data(symbol[Dt+i]);
 }
++z;
}
}

void put_big_byte (unsigned char Data)
{
 unsigned char X=Tmp_x;
 unsigned char Y=Tmp_y;
 unsigned char D1=0,D2=0;
 if(Data&0x80) D1|=0xC0;
 if(Data&0x40) D1|=0x30;
 if(Data&0x20) D1|=0x0C;
 if(Data&0x10) D1|=0x03;
 if(Data&0x08) D2|=0xC0;
 if(Data&0x04) D2|=0x30;
 if(Data&0x02) D2|=0x0C;
 if(Data&0x01) D2|=0x03;
 LCD_data(D2);
 LCD_data(D2);
 cursor(X,(Y+1));
 LCD_data(D1);
 LCD_data(D1);
 cursor((X+2),Y);
}

void printf_big (const char * Dtm, ...)
{
 Dtm[14];
 char z=0;
 while(Dtm[z]!='\0')
{
 Dt=Dtm[z];
 if(Dt>9)        // ,     
 {
  if(Dt>0x7D)
   Dt=(Dt-0x41); //         ASCCI
  Dt=(Dt-0x20);  //         ASCCI
 }
 else
  Dt=Dt+16;      // 16-  ='0'
 unsigned char i;
 Dt=Dt*6;
 for(i=0;i<6; i++)
 {
  put_big_byte(symbol[Dt+i]);
 }
++z;
}
}

void Print_txt (unsigned int Dt)
{
 if(Dt>9)        // ,     
 {
  if(Dt>0x7D)
   Dt=(Dt-0x41); //         ASCCI
  Dt=(Dt-0x20);  //         ASCCI
 }
 else
  Dt=Dt+16;      // 16-  ='0'
 unsigned char i;
 Dt=Dt*6;
 for(i=0;i<6; i++)
 {
  LCD_data(symbol[Dt+i]);
 }
}


void Print_txt_big (unsigned int Dt)
{
 if(Dt>9)        // ,     
 {
  if(Dt>0x7D)
   Dt=(Dt-0x41); //         ASCCI
  Dt=(Dt-0x20);  //         ASCCI
 }
 else
  Dt=Dt+16;      // 16-  ='0'
 unsigned char i;
 Dt=Dt*6;
 for(i=0;i<6; i++)
 {
  put_big_byte(symbol[Dt+i]);
 }
}



void print_10_big(unsigned long tmp, unsigned char F)
{
 unsigned char flag=0;
 if(tmp==0)
  Print_txt_big(0);
 else
 {
  Bin2_10(tmp);
  if((Dat6>0)||(flag==1))
  {Print_txt_big(Dat6);flag=1;}
  if((Dat5>0)||(flag==1))
  {Print_txt_big(Dat5);flag=1;}
  if((Dat4>0)||(flag==1))
  {Print_txt_big(Dat4);flag=1;}
  if(F==1)
  {
   Print_txt_big(Dat3);
   Print_txt_big(',');
   cursor((Tmp_x-2),Tmp_y);
   Print_txt_big(Dat2);
   Print_txt_big(Dat1);
  }
  else if(F==0)
  {
   if((Dat3>0)||(flag==1))
   {Print_txt_big(Dat3);flag=1;} 
   Print_txt_big(Dat2);
   Print_txt_big(',');
   cursor((Tmp_x-2),Tmp_y);
   Print_txt_big(Dat1);
  }
  else if(F==2)
  {
   if((Dat3>0)||(flag==1))
   {Print_txt_big(Dat3);flag=1;} 
   Print_txt_big(',');
   Print_txt_big(Dat2);
  }
  else if(F==3)
  {
   if((Dat3>0)||(flag==1))
   {Print_txt_big(Dat3);flag=1;} 
   Print_txt_big(Dat2);
  }
 } 
}
